unit Glav;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, Series, TeeProcs, Chart, ComCtrls, StdCtrls, ExtCtrls,
  Buttons,DateUtils, Grids, jpeg, Spin, TeeFunci;


type
  TF_Glav = class(TForm)
    TabControl1: TTabControl;
    TabControl2: TTabControl;
    GroupBox1: TGroupBox;
    StringGrid1: TStringGrid;
    Panel1: TPanel;
    Chart1: TChart;
    Series1: TFastLineSeries;
    Series2: TFastLineSeries;
    Series3: TFastLineSeries;
    Panel3: TPanel;
    GroupBox2: TGroupBox;
    pan2: TPanel;
    Panel2: TPanel;
    pan1: TPanel;
    Lb_tok_max: TPanel;
    Lb_tok_nom: TPanel;
    Lb_moshn: TPanel;
    Panel4: TPanel;
    BitBtn1: TBitBtn;
    Button2: TButton;
    DateTimePicker1: TDateTimePicker;
    Panel5: TPanel;
    SpinEdit1: TSpinEdit;
    ButtonPrevious: TBitBtn;
    ButtonNext: TBitBtn;
    BLastPage: TBitBtn;
    BFirstPage: TBitBtn;
    Panel6: TPanel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Button3: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Series4: TLineSeries;
    Panel8: TPanel;
    BitBtn6: TBitBtn;
    Button5: TButton;
    Label9: TLabel;
    Label10: TLabel;
    SaveDialog1: TSaveDialog;
    Button1: TButton;
    procedure Button2Click(Sender: TObject);
    procedure DateTimePicker1Change(Sender: TObject);
    procedure TabControl2Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
    procedure Series1AfterDrawValues(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure Chart1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BFirstPageClick(Sender: TObject);
    procedure BLastPageClick(Sender: TObject);
    procedure ButtonNextClick(Sender: TObject);
    procedure ButtonPreviousClick(Sender: TObject);
    procedure Chart1PageChange(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
     tmpY ,tmpX :Double;
     OldX,tmp_elem:Longint;
    N_Color:TColor;
    N_Style:TPenStyle;

   end;

   TZipVremyaTokVseh = record
      Vremya: TDateTime;
      Tok : array [1..72] of real;
   end;

    
   ZipInfo = Record
      Name : String[50];
      T_nom: real;
      T_max: real;
      Moshn: real;


   end;



    TZipDvigInfo = array [1..72] of ZipInfo;
    TZipMas = array [0..65000] of TZipVremyaTokVseh;

var
  F_Glav: TF_Glav;
  ZipDviginfo : TZipDvigInfo;
  ZipMas: TZipMas;
  ZipMas_Tmp: TZipMas;
  CurrentPath: String;
  file_Put: String[80];
   x_temp, j:integer;
   Clik_X:Longint;

implementation

uses Put, Arhiv_pokaz, MyExcel, F_Zapis,Inifiles;

{$R *.dfm}

(***********************************************)
// ------------.INI file R/W:-------------------

procedure SaveConfig;
var
 RegKey: TIniFile;
begin
 RegKey := TIniFile.Create(CurrentPath+Application.Title+'.INI');
 with RegKey do
  begin
   WriteString('General','Put',file_Put);
   Free;
  end;
end;

(*******************************)

procedure ReadConfig;
var
 RegKey: TIniFile;
begin
 RegKey := TIniFile.Create(CurrentPath+Application.Title+'.INI');
 with RegKey do
  begin
   file_Put:=ReadString('General','Put','');
   Free;
  end;
end;

(***********************************************)
procedure Jcheyka(Coll:byte;Roww:Word);
 begin
  With F_Glav.StringGrid1 do
      begin
      Col:=Coll;
      Row:=Roww;
      end;
 end;

(****************************************)
procedure steret(OldX:Longint);
begin

     With F_Glav.Chart1,Canvas do       // 
  begin
      Pen.Color:=clYellow;
      Pen.Mode:=pmXor;  //         ,   
      Pen.Width:=1;
      MoveTo( OldX,ChartRect.Top-Height3D); //    Y
      LineTo( OldX,ChartRect.Bottom-Height3D);  //     Y  

  end;
end;
(****************************************)

procedure TF_Glav.Button2Click(Sender: TObject);
begin
F_Put.Show;
end;
 (**************************************)
procedure TF_Glav.DateTimePicker1Change(Sender: TObject);
begin
end;
  (**************************************)
procedure TF_Glav.TabControl2Change(Sender: TObject);
begin
  obnov_arhiv(False);
end;

(***********************************)

procedure TF_Glav.FormCreate(Sender: TObject);
begin
F_Glav.DateTimePicker1.Date:=(DateOf(Now));
  OldX:=-1;

   Chart1.ScaleLastPage:=True;
   SpinEdit1.Value:=0;         { <-- max number of points per page }
  Chart1PageChange(Chart1);    { <-- repaint page / number of pages }

    CurrentPath:=ExtractFilePath(ParamStr(0));   //      DATA
 ReadConfig;
  end;

 (**************************************)
procedure TF_Glav.BitBtn1Click(Sender: TObject);
begin
   obnov_arhiv(True);
end;

 (**************************************)
procedure TF_Glav.Button3Click(Sender: TObject);
begin
Chart1.UndoZoom;
end;

(**************************************)
procedure TF_Glav.TabControl1Change(Sender: TObject);
var number_Paneli:integer;
begin

  number_Paneli:= F_Glav.TabControl1.TabIndex+1;
  vibor(number_Paneli);
    obnov_arhiv(False);
end;
 (**************************************)
procedure TF_Glav.Series1AfterDrawValues(Sender: TObject);
begin
 OldX:=-1;  { Reset old mouse position }
end;
(**************************************)
procedure TF_Glav.StringGrid1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
var
  Difer: Double;
begin

 if (ACol=1)or(ACol=2)or(ACol=3)then
 begin
   j:=ARow;      //   

      if (OldX<>-1) then
           begin
               steret(OldX);
               OldX:= -1;
           end;

   tmp_elem:= Chart1.BottomAxis.CalcXPosValue( j ) ;

 (*-----------------------------------------------*)
  if ((Chart1.ChartRect.Left >= tmp_elem)) then
   Begin // 
      Difer:=F_Glav.Chart1.BottomAxis.Maximum - F_Glav.Chart1.BottomAxis.Minimum;
      Chart1.BottomAxis.Minimum := j - Difer/2;
      Chart1.BottomAxis.Maximum := Chart1.BottomAxis.Minimum + Difer;
   End;

  if ((tmp_elem >= Chart1.ChartRect.Right)) then
   Begin // 
      Difer:=F_Glav.Chart1.BottomAxis.Maximum - F_Glav.Chart1.BottomAxis.Minimum;
      Chart1.BottomAxis.Maximum := j + Difer/2;
      Chart1.BottomAxis.Minimum := Chart1.BottomAxis.Maximum - Difer;
   End;

    (*-----------------------------------------------*)

  if ((Chart1.ChartRect.Left <= tmp_elem) and(tmp_elem <= Chart1.ChartRect.Right)) then
  begin
     With Chart1,Canvas do
      begin
      x_temp:=tmp_elem-1;              //  
      Pen.Color:=clYellow;
      Pen.Style:=psSolid;
      Pen.Mode:=pmXor;    //         ,   
      Pen.Width:=1;
      MoveTo(x_temp,ChartRect.Top-Height3D);  //    Y
      LineTo(x_temp,ChartRect.Bottom-Height3D);    //     Y  
      end;
   OldX:=x_temp;
  end;

  end;

end;

(****************************************)
procedure TF_Glav.Chart1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if (OldX<>-1) then
  begin
    steret(OldX);
    OldX:=-1;
  end;
  (*-----------------------------------------------*)
  if PtInRect( Chart1.ChartRect, Point(X-Chart1.Width3D,Y+Chart1.Height3D)  ) then
  begin
    With Chart1,Canvas do
    begin
      Pen.Color:=clYellow;
      Pen.Mode:=pmXor;
      Pen.Width:=1;
      MoveTo( X,ChartRect.Top-Height3D);
      LineTo( X,ChartRect.Bottom-Height3D);
     end;
  OldX:=x;
   (*-----------------------------------------------*)

  With Series1 do         //    Series1
    begin
      GetCursorValues(tmpX,tmpY);
      Clik_X:=(round(tmpX));   //   
    end;
    if Clik_X > nn then Clik_X:=nn-1;
    if Clik_X <0   then Clik_X:=1;

      Jcheyka(1,Clik_X);
end;
 
end;

(****************************************)

procedure TF_Glav.BFirstPageClick(Sender: TObject);
begin
Chart1.Page:=1;  { go to first page }
end;
(****************************************)

procedure TF_Glav.BLastPageClick(Sender: TObject);
begin
 Chart1.Page:=Chart1.NumPages;  { go to last page }
end;
(****************************************)

procedure TF_Glav.ButtonNextClick(Sender: TObject);
begin
 Chart1.NextPage;  { <-- goto next chart page }
end;

(****************************************)
procedure TF_Glav.ButtonPreviousClick(Sender: TObject);
begin
Chart1.PreviousPage; { <-- goto previous chart page }
end;

(****************************************)
procedure TF_Glav.Chart1PageChange(Sender: TObject);
begin
   Chart1.UndoZoom;
   Label6.Caption:=IntToStr(Chart1.Page);
   Label4.Caption:=IntToStr(Chart1.NumPages);
end;
(****************************************)

(****************************************)
procedure TF_Glav.SpinEdit1Change(Sender: TObject);
begin
  Chart1.MaxPointsPerPage:=round(nn/SpinEdit1.Value*1.5);
  Chart1PageChange(Chart1); { <--   / ()   }
end;
(****************************************)
procedure TF_Glav.Button4Click(Sender: TObject);
var i, k,m,diagram,a_:integer;

(*--------------  exel-----------------*)
begin

if not CreateExcel then exit;
VisibleExcel(false);

 if nn<32000 then  begin
  if AddWorkBook then SelectSheet(1);
                      end;

  {*****************************}

 if nn>32000 then  begin

 if AddWorkBook then SelectSheet(2);
                      end;

{--------------------------}
 k:=round(nn/100);
 m:=0;
 diagram:=0;

 Zapis.Visible:=true;


for a_:=1 to nn do begin
               m:=m+1;
         if m=k then
            begin
        diagram:=diagram+1;
         m:=0;
            end;

 Zapis.Gauge1.Progress:=diagram;
  Zapis.ProgressBar1.Position:=diagram;

   if a_<32000 then  begin
    SetRange(1,'A'+inttostr(a_),ZipMas[a_].Vremya);
    SetRange(1,'B'+inttostr(a_),ZipMas[a_].Tok[1]);
    SetRange(1,'C'+inttostr(a_),ZipMas[a_].Tok[2]);
    SetRange(1,'D'+inttostr(a_),ZipMas[a_].Tok[3]);
    SetRange(1,'E'+inttostr(a_),ZipMas[a_].Tok[4]);
    SetRange(1,'F'+inttostr(a_),ZipMas[a_].Tok[5]);
    SetRange(1,'G'+inttostr(a_),ZipMas[a_].Tok[6]);
    SetRange(1,'H'+inttostr(a_),ZipMas[a_].Tok[7]);
    SetRange(1,'I'+inttostr(a_),ZipMas[a_].Tok[8]);
                     end;

  {*****************************}

 if a_>32000 then  begin

    SetRange(2,'A'+inttostr(a_),ZipMas[a_].Vremya);
    SetRange(2,'B'+inttostr(a_),ZipMas[a_].Tok[1]);
    SetRange(2,'C'+inttostr(a_),ZipMas[a_].Tok[2]);
    SetRange(2,'D'+inttostr(a_),ZipMas[a_].Tok[3]);
    SetRange(2,'E'+inttostr(a_),ZipMas[a_].Tok[4]);
    SetRange(2,'F'+inttostr(a_),ZipMas[a_].Tok[5]);
    SetRange(2,'G'+inttostr(a_),ZipMas[a_].Tok[6]);
    SetRange(2,'H'+inttostr(a_),ZipMas[a_].Tok[7]);
    SetRange(2,'I'+inttostr(a_),ZipMas[a_].Tok[8]);

                      end;
                  end;
   Zapis.Visible:=false;//hide;
{--------------------------}
   SaveDialog1.Filter:=' Excel|*.xls';
   SaveDialog1.Execute;
{--------------------------}

   SaveWorkBookAs(SaveDialog1.FileName);
   CloseWorkBook;
   CloseExcel;
{---------------------------}

end;
(****************************************)

procedure TF_Glav.BitBtn2Click(Sender: TObject);
begin
 Chart1.ZoomPercent(120);
end;

(****************************************)
procedure TF_Glav.BitBtn3Click(Sender: TObject);
begin
Chart1.ZoomPercent(80);
end;

 (****************************************)
procedure TF_Glav.FormDestroy(Sender: TObject);
begin
SaveConfig;
end;

procedure TF_Glav.Button1Click(Sender: TObject);
begin
  Chart1.Page:=1;
  Chart1.MaxPointsPerPage:=round(0);

  Label6.Caption:=IntToStr(Chart1.Page);
  Label4.Caption:=IntToStr(Chart1.NumPages);
  SpinEdit1.Text:='1';
end;

end.
