unit ZAGRUZKI;

interface
uses  Classes,Forms,IniFiles, Graphics,ExtCtrls;


procedure Func_Preobraz;
procedure zagruz_ustav(number:byte);
PROCEDURE nach_zagruz;
procedure Sohran_Ustavok;
procedure ReadConfig(number:integer);  (* 1..72 *)
procedure SaveConfig(number:integer); (* 1..72 *)
procedure controll;
procedure Klik_Number(number:byte);

var Ini: TIniFile;
    CurrentPath: String;


implementation

uses Glav, Grafik, KALIBROWKA, SysUtils,DateUtils, ZAG_KOOF, Grafic, skor,
  arhiv, Arhiv_Resurs;



(********************************)

procedure controll;
var Panl:TComponent;
   ji:byte;
begin
for ji:=1 to 72 do


begin
     Panl:= Form1.FindComponent('Pan' + IntToStr(ji));

  (*--------------------------------------*)
  if  ( MasDvigInfo[ji].T_max < MasTV[ji,i].Tok) then
 begin (Panl as TPanel).color := clRed;  end
 else

 if ( MasDvigInfo[ji].T_nom < MasTV[ji,i].Tok)and
    ( MasDvigInfo[ji].T_max > MasTV[ji,i].Tok) then
 begin (Panl as TPanel).color := clYellow;  end
 else

  if ( MasDvigInfo[ji].T_off < MasTV[ji,i].Tok)and
     ( MasDvigInfo[ji].T_nom > MasTV[ji,i].Tok) then
 begin (Panl as TPanel).color :=clLime;  end
 else

  if ( MasDvigInfo[ji].T_nom > MasTV[ji,i].Tok) then
 begin (Panl as TPanel).color := clScrollBar;  end;
 (*--------------------------------------*)
 end;
end;
// ------------.INI file R/W:-------------------

procedure SaveConfig(number:integer); (* 1..72 *)
var
 RegKey: TIniFile;
begin
  RegKey := TIniFile.Create(CurrentPath+Application.Title+'.INI');
 with RegKey do
  begin
   WriteString ('Ustavki'+IntToStr(Number),'Name',MasDvigInfo[number].Name);
   WriteFloat	('Ustavki'+IntToStr(Number),'Koof_K',MasDvigInfo[number].Koof_K);
  WriteFloat	('Ustavki'+IntToStr(Number),'Koof_B',MasDvigInfo[number].Koof_B);
  WriteFloat('Ustavki'+IntToStr(Number),'T_Nom',MasDvigInfo[number].T_nom);
   WriteFloat('Ustavki'+IntToStr(Number),'T_Max',MasDvigInfo[number].T_max);
   WriteInteger('Ustavki'+IntToStr(Number),'Moshn',MasDvigInfo[number].moshn);
   WriteInteger('Ustavki'+IntToStr(Number),'Oborot',MasDvigInfo[number].T_off);
   Free;
  end;
end;

(*******************************)

procedure ReadConfig(number:integer);  (* 1..72 *)
var
 RegKey: TIniFile;
begin
RegKey := TIniFile.Create(CurrentPath+Application.Title+'.INI');
try
 with RegKey do
  begin
   MasDvigInfo[number].Name  :=ReadString ('Ustavki'+IntToStr(Number),'Name',IntToStr(number));
   MasDvigInfo[number].Koof_K:=ReadFloat	('Ustavki'+IntToStr(Number),'Koof_K',50);
   MasDvigInfo[number].Koof_B:=ReadFloat	('Ustavki'+IntToStr(Number),'Koof_B',1);
   MasDvigInfo[number].T_nom :=ReadFloat  ('Ustavki'+IntToStr(Number),'T_Nom',560);
   MasDvigInfo[number].T_max :=ReadFloat  ('Ustavki'+IntToStr(Number),'T_Max',540);
   MasDvigInfo[number].moshn :=ReadInteger('Ustavki'+IntToStr(Number),'Moshn',200);
   MasDvigInfo[number].T_off:=ReadInteger('Ustavki'+IntToStr(Number),'Oborot',320);
   Free;
  end;
 except
 end;
end;
(*************************************)

procedure Sohran_Ustavok;
var ji:integer;
begin
  for ji:=1 to 72 do begin
   SaveConfig(ji);
   F_ZAGk.Gauge1.Progress:=ji;
                      end;   
end;

(********************************)

PROCEDURE nach_zagruz;
var ij:integer;
begin

for  ij:=1 to 72 do
 begin
 MasDvigInfo[ij].Name:=' ';
 MasDvigInfo[ij].Koof_K:=0;
 MasDvigInfo[ij].Koof_B:=0;
 MasDvigInfo[ij].T_nom:=0;
 MasDvigInfo[ij].T_max:=0;
 MasDvigInfo[ij].moshn:=0;
 MasDvigInfo[ij].T_off:=0;
 end;


  for ij:=1 to 72 do  begin
  ReadConfig(ij);
  F_ZAGk.Gauge1.Progress:=ij;
                      end;
end;

(*****************************)

procedure Func_Preobraz;
var j:byte;
begin
   for j:=1 to 72 do
   begin
   if 0< (round(MasTV[j,i].Tok*MasDvigInfo[j].Koof_K-MasDvigInfo[j].Koof_B)) then
   MasTV[j,i].Tok:=round(MasTV[j,i].Tok*MasDvigInfo[j].Koof_K-MasDvigInfo[j].Koof_B)
   else   begin MasTV[j,i].Tok:=0; end;
   MasTV[j,i].Vremya:=Time;
  end;
end;
(********************************)

procedure zagruz_ustav(number:byte);
begin
 (*   *)
 With F_grafik.Chart1.Title.Text do
begin
	Clear;
	Add(MasDvigInfo[number].Name );  (*    *)
end;
 F_grafik.Chart1.Repaint;

 F_grafik.GroupBox1.Caption:=MasDvigInfo[number].Name ;  (*    *)
 F_grafik.Lb_tok_nom.Caption:=FloatToStr(MasDvigInfo[number].T_nom);
 F_grafik.Lb_tok_max.Caption:=FloatToStr(MasDvigInfo[number].T_max);
 F_grafik.Lb_moshn.Caption:=intToStr(MasDvigInfo[number].moshn);  (*   *)
 F_GRAF.Pl_nom.Caption:=FloatToStr(MasDvigInfo[number].T_nom);        (*    *)

  (********************************)
 (*   *)
 F_Kalibr.Edit1.Text := MasDvigInfo[number].Name;
 F_Kalibr.Edit2.Text:=FloatToStr( MasDvigInfo[number].Koof_K);
 F_Kalibr.Edit3.Text:=FloatToStr(MasDvigInfo[number].Koof_B);
 F_Kalibr.Edit4.Text:=FloatToStr(MasDvigInfo[number].T_nom);
 F_Kalibr.Edit5.Text:=FloatToStr(MasDvigInfo[number].T_max);
 F_Kalibr.MaskEdit5.Text:=intToStr(MasDvigInfo[number].moshn);
 F_Kalibr.MaskEdit6.Text:=intToStr(MasDvigInfo[number].T_off);

  (********************************)
 (*   *)
   //skorost.MaskEdit7.Text:=intToStr(SrdArefm);
 DVIGATEL:=number;
 end;


(********************************)
procedure Klik_Number(number:byte);
 var ij:integer;

begin
F_grafik.Show;
F_grafik.Chart1.SeriesList[0].Clear;
F_grafik.Chart1.SeriesList[1].Clear;
F_grafik.Chart1.SeriesList[2].Clear;

for ij:=1 to 3000 do
 begin
   F_grafik.Chart1.SeriesList[0].AddXY(ij,(MasTV[number,(ij+i-1) mod 3001]).Tok,
   TimeToStr((MasTV[number,(ij+i-1) mod 3001]).Vremya));
  
F_grafik.Chart1.SeriesList[1].AddXY(ij,( MasDvigInfo[number].T_nom));
F_grafik.Chart1.SeriesList[2].AddXY(ij,( MasDvigInfo[number].T_max));

  end;
end;
(********************************)

end.

